﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Text;


namespace DataMapper
{
    /// <summary>
    /// Cette classe d'attribut permet de marquer les propriétés dont le chargement / déchargement seront gerés autmatiquement.
    /// Cela permet de ne plus avoir de dependance au code gerant la base de donnés dans les classes metiers
    /// <remarks>Le nom de la proprieté n'est pas obligé de matcher avec le nom de la colonne en base</remarks>
    /// <remarks>Les accesseurs get et set doivent exister tous les deux mais il n'ya pas de contrainte sur leur visibilités.
    /// Ils peuvent donc être privé pour renforcer la modèlisation objet de la DAL</remarks>
    /// <example>
    /// [DbMappedTable("Assets")]
    /// public class clsAsset
    /// {
    ///    [DbMappedField("Asset_ID")]
    ///    public int Id { get; private set; }
    /// }
    /// </example>
    /// </summary>
    [AttributeUsage(AttributeTargets.Property)]
    [DebuggerDisplay("{" + nameof(DebugString) + ",nq}")]
    public class DbMappedField : DbMappedPropertyAttribute
    {
        public    string ColumnName          { get; internal set; }
        public    string ColumnNameProtected { get { return "[" + ColumnName + "]"; } }
        public      bool IsPK                { get; set; } // True if column is unique for each entity
        public      bool IsAutoIncremented   { get; set; } // True if value is auto incremented by DB on insert
        [DebuggerBrowsable(DebuggerBrowsableState.Never)]
        public      bool IsAutoPK            { get { throw new InvalidOperationException(); }
                                               set { IsPK = IsAutoIncremented = value; } } // Allow to set both IsPK and IsAutoGenerated to true
        /// <summary>
        /// When IsPK = true, this index allow to order the property/column defintiion to compose the tuple primary key.
        /// This value is mandatory if there is more than one PK field.
        /// When there is multiple field in a PK, the implementation of <see cref="BaseDTO{TIdTuple}.ClosedId"/> or <see cref="TechnicalTools.Model.Cache.IHasClosedIdReadable.Id"/>
        /// must return an IdTuple instance where keys are in the same order.
        /// Values allowed goes from 1 or above.
        /// </summary>
        public       int KeyOrderIndex       { get; set; }

        public      bool IsNullable          { get; set; }
        public      bool IsComputed          { get; set; }
        public eEncoding Encoding            { get; set; } = eEncoding.Unicode;

        public      bool UseDefaultOnInsert  { get; set; }
        public      bool HasDefaultValue     { get; private set; }
        public    object DefaultValue        { get; set; }
        public       int OrdinalIndex        { get; internal set; } // Just a unique Id (not necessarly the columnOrderIndex of the column in table) among all the column belonging to the same table

        public Func<object, object> ConvertDbToCsValue { get; internal set; }
        public Func<object, object> ConvertCsToDbValue { get; internal set; }
        internal int                DeclaredAtLine     { get; private set; }

        //[Obsolete("Remove \"...FkTo = typeof(Foo)...\" from " + nameof(DbMappedField) +
        //          "and add \"[" + nameof(DbForeignKey) + "(typeof(Foo))]\"")]
        public Type FkTo { get { throw new Exception($"{nameof(FkTo)} is obsolete! Use {nameof(ForeignKeys)} or {nameof(DbMappedTable)}.{nameof(DbMappedTable.ForeignKeys)})"); } set { OldFkTo = value; } }
        internal Type OldFkTo { get; set; }

        public IEnumerable<DbForeignKey> ForeignKeys { get { return Table.ForeignKeys.Where(fk => fk.Keys.Any(fkf => fkf == this)); } }

        internal string DebugString
        {
            get
            {
                return nameof(Table) + "=" + Table?.FullName + ", " +
                       nameof(ColumnName) + "=" + ColumnName + ", " +
                       nameof(IsPK) + "=" + IsPK + ", " +
                       (DefaultValue == null ? "" : nameof(DefaultValue) + "=" + DefaultValue + ", ") +
                       nameof(IsNullable) + "=" + IsNullable + ", " +
                       nameof(PropertyInfo) + "=" + PropertyInfo?.PropertyType.Name + ", " +
                       nameof(KeyOrderIndex) + "=" + KeyOrderIndex;
            }

        }

        public object GetValue(object owner)
        {
            return PropertyInfo.GetValue(owner, null);
        }

        public object GetValueDirect<TObject>(TObject obj)
        {
            return GetDirectGetAccessor<TObject>()(obj);
        }
        public Func<TObject, object> GetDirectGetAccessor<TObject>()
        {
            if (_GetCompiled == null)
                lock (_GetCompiledLock)
                    if (_GetCompiled == null)
                    {
                        Debug.Assert(Table != null, "Use the original DbmappedField attribute not a copy");
                        Debug.Assert(Table.MappedType == typeof(TObject), "Cannot build accessor fort this type. This is not the original mapped type");
                        _GetCompiled = CreatePropertyAccessor<TObject>(PropertyInfo);
                    }
            return (Func<TObject, object>)_GetCompiled;
        }

        object _GetCompiled;
        readonly object _GetCompiledLock = new object();
        Func<TObject, object> CreatePropertyAccessor<TObject>(PropertyInfo p)
        {
            var values = __CreatePropertyAccessor(p, typeof(TObject));
            // Create a lambda expression for the property access and compile it
            var lamda = Expression.Lambda<Func<TObject, object>>(values.Item1, values.Item2);
            return lamda.Compile();
        }
        Tuple<UnaryExpression, ParameterExpression> __CreatePropertyAccessor(PropertyInfo p, Type t)
        {
            Debug.Assert(t == Table.MappedType);
            // Define the parameter that will be passed - will be the current object
            var parameter = Expression.Parameter(t, "input");
            // Define an expression to get the value from the property
            //var propertyAccess = Expression.Property(parameter, p.GetGetMethod(true)); // this line does not work if p is declared in base class of TObject
            Expression cParameter = p.DeclaringType == t
                                  ? (Expression)parameter
                                  : Expression.ConvertChecked(parameter, p.DeclaringType); // needed if property is declared in base class
            var propertyAccess = Expression.Property(cParameter, p);
            // Make sure the result of the get method is cast as an object
            var castAsObject = Expression.TypeAs(propertyAccess, typeof(object));
            // Create a lambda expression for the property access and compile it
            return Tuple.Create(castAsObject, parameter);
        }

        public void SetValue<TPropertyValue>(object owner, TPropertyValue value) // Methode générique pour éviter de boxer les valeurs
        {
            PropertyInfo.SetValue(owner, value, BindingFlags.Default, null, null, null);
        }
        public object GetDbValue(object owner)
        {
            return ConvertCsToDbValue(GetValue(owner));
        }
        public void SetDbValue(object owner, object db_value)
        {
            // Parce que pour l'instant il y'a trop de difference entre les base sur la nullabilité des champs
            if (db_value == DBNull.Value)
            {
                // On test en gros que le type est soit Nullable(Of ...) soit string
                //DebugTools.CostlyAssert(PropertyInfo.PropertyType.IsGenericType ||
                //                        PropertyInfo.PropertyType == typeof(string),
                //                        string.Format("Dans la classe \"{0}\", la propriété \"{1}\" est de type \"{2}\".", owner.GetType().FullName, PropertyInfo.Name, PropertyInfo.PropertyType.Name) + Environment.NewLine +
                //                        string.Format("Or, la colonne \"{0}\" de la table \"{1}\" sur laquelle est bindé cette propriété est nullable !", FieldName, Table.TableName) + Environment.NewLine +
                //                        string.Format("Merci de corriger le type de cette propriété en \"Nullable(Of {0})\"", PropertyInfo.PropertyType.Name));
                //SetValue(owner, DefaultValue);
                PropertyInfo.SetValue(owner, null, BindingFlags.Default, null, null, null);
                return;
            }

            object value = ConvertDbToCsValue(db_value);
            if (_setDbValue == null)
            {
                if (PropertyInfo.PropertyType.IsEnum)
                {
                    var t = PropertyInfo.PropertyType;
                    _setDbValue = (o, v) => PropertyInfo.SetValue(o, Enum.Parse(t, v.ToString(), true), BindingFlags.Default, null, null, null);
                }
                else if (PropertyInfo.PropertyType.IsGenericType &&
                         PropertyInfo.PropertyType.GetGenericArguments().First().IsEnum)
                {
                    //Cas enum ou Nullable(enum)
                    var t = PropertyInfo.PropertyType.GetGenericArguments().First();
                    _setDbValue = (o, v) => PropertyInfo.SetValue(o, Enum.Parse(t, v.ToString(), true), BindingFlags.Default, null, null, null);
                }
                else if (PropertyInfo.PropertyType == typeof(char)) // Et type nullable  ? ...a faire
                {
                    _setDbValue = (o, v) => PropertyInfo.SetValue(o, ((string)v)[0], BindingFlags.Default, null, null, null);
                }
                else // Autre cas standart
                {
                    _setDbValue = (o, v) =>
                    {
                        PropertyInfo.SetValue(o, v, BindingFlags.Default, null, null, null);
                    };
                }
            }
            _setDbValue(owner, value);
        }
        Action<object, object> _setDbValue;

        public string GetDbStringValue(object owner)
        {
            object value = GetValue(owner);
            return ToSql(value);
        }

        public string GetFilter(object owner, bool revert = false)
        {
            object value = GetValue(owner);
            if (value == null || value == DBNull.Value)
                return ColumnNameProtected + " IS " + (revert ? "NOT " : string.Empty) + ToSql(value);
            return ColumnNameProtected + (revert ? " <> " : " = ") + ToSql(value);
        }

        public static string ToSql(object value)
        {
            if (value == null || value == DBNull.Value)
                return "NULL";
            if (value is string)
                return "N'" + Convert.ToString(value).Replace("'", "''") + "'";
            if (value is bool)
                return Convert.ToBoolean(value) ? "1" : "0";
            if (value is DateTime)
                return "'" + ((DateTime)value).ToString("yyyy'-'MM'-'dd'T'HH':'mm':'ss'.'fff") + "'"; // ISO 8601
            if (value is TimeSpan)
                return "'" + ((TimeSpan)value).ToString("hh':'mm':'ss'.'fffffff") + "'";
            if (value is Enum)
                return Convert.ToInt32(value).ToString(CultureInfo.InvariantCulture);
            if (value is DynamicEnum)
                return (value as DynamicEnum).EnumId.ToString(CultureInfo.InvariantCulture);
            if (value is Guid guid)
                return "N'" + guid.ToString() + "'";
            if (value is IFormattable formattable)
                return formattable.ToString(null, CultureInfo.InvariantCulture);
            if (value is char)
                return "N'" + value.ToString() + "'";
            if (value is Version)
                return "N'" + value.ToString() + "'";
            if (value is byte[])
            {
                var bytes = value as byte[];
                var sb = new StringBuilder(2 + bytes.Length * 2);
                sb.Append("0x");
                foreach (byte b in bytes)
                    sb.AppendFormat("{0:x2}", b);
                while (sb[sb.Length - 1] == '-')
                    sb.Length = sb.Length - 1;
                return sb.ToString();
            }

            throw new NotImplementedException(string.Format("Not sure of to convert {0} to sql representation", value));
        }

        public DbMappedField(string field_name, [CallerLineNumber] int declOrder = 0)
        {
            ColumnName = field_name;
            KeyOrderIndex = -1;
            DeclaredAtLine = declOrder;
        }
    }

    public enum eEncoding
    {
        Unicode,     // Type nchar nvarchar, ntext en SQL
        Iso_8859_1,  // Type char varchar, text en SQL si défini comme tel par la BDD
        Iso_8859_9,  // Type char varchar, text en SQL si défini comme tel par la BDD
        Iso_8859_15,  // Type char varchar, text en SQL si défini comme tel par la BDD
    }
}
